#include <stdio.h>
#include "defs.h"


char *fgetline (FILE *);


char *
fgetline (FILE * stream)
{
  char c, *line, readflag;
  unsigned long long linesize;

  if (LINEBUFFSIZE == 0)
    return NULL;

  readflag = 1;
  linesize = 0;
  line = (char *) malloc (LINEBUFFSIZE * sizeof (char));
  if (line == NULL)
    {
      perror ("Error");
      readflag = 0;
    }
  else
    line[0] = '\0';

  c = getc (stream);
  while (!feof (stream) && readflag)
    {
      line[linesize] = c;
      linesize++;
      if ((linesize % LINEBUFFSIZE) == 0)
	{
	  line =
	    (char *) realloc (line,
			      (linesize + LINEBUFFSIZE) * sizeof (char));
	  if (line == NULL)
	    {
	      perror ("Error");
	      readflag = 0;
	    }
	}
      if (c == '\n')
	readflag = 0;
      else
	c = getc (stream);
    }

  if (line != NULL)
    line[linesize] = '\0';

  return line;
}
