#include <stdio.h>
#include <string.h>


char *
trimcrlf (char *input)
{
  if (input == NULL)
    return NULL;

  if (input[strlen (input) - 1] == '\n')
    input[strlen (input) - 1] = 0;
  if (input[strlen (input) - 1] == '\r')
    input[strlen (input) - 1] = 0;

  return input;
}


char *
removeblanks (char *input)
{
  char *retstr;
  unsigned long long x, y;

  if (input == NULL)
    return input;

  if (input[0] == 0)
    return input;

  retstr = (char *) malloc (strlen (input) * sizeof (char) + 1);
  if (retstr == NULL)
    {
      perror ("Error");
      return NULL;
    }

  for (x = 0, y = 0; x < strlen (input); x++)
    {
      if ((input[x] != ' ') && (input[x] != '\t'))
	{
	  retstr[y] = input[x];
	  y++;
	}
    }
  retstr[y] = 0;

  return retstr;
}


long
str2int (char *input)
{
  int i;
  long base, result;

  base = 1;
  result = 0;

  if (input == NULL)
    return result;

  for (i = strlen (input) - 1; i > -1; i--)
    {
      if (isdigit (input[i]))
	{
	  result += (input[i] - '0') * base;
	  base *= 10;
	}
      else
	i = -1;
    }
  return result;
}


char *
substr (char *input, unsigned long begin, unsigned long length)
{
  unsigned long l;
  char *retstr;

  if (input == NULL)
    return input;

  if (input[0] == 0)
    return input;

  retstr = (char *) malloc (strlen (input) * sizeof (char) + 1);
  if (retstr == NULL)
    {
      perror ("Error");
      return NULL;
    }

  l = strlen (input);

  if (begin > l)
    return NULL;

  if (begin + length - 1 > l)
    length = l - begin + 1;

  for (l = begin; l < begin + length; l++)
    retstr[l - begin] = input[l - 1];
  retstr[l - begin] = 0;

  return retstr;
}


long
str2mili (char *input)
{
  int i;
  long base, result;

  base = 100;
  result = 0;

  if (input == NULL)
    return result;

  for (i = 0; i < strlen (input); i++)
    {
      if (isdigit (input[i]))
	{
	  result += (input[i] - '0') * base;
	  if (base > 1)
	    base /= 10;
	  else
	    i = strlen (input);
	}
      else
	i = strlen (input);
    }

  return result;
}


char *
number2blanks (char *input)
{
  char *retstr;
  unsigned long long x;

  if (input == NULL)
    return input;

  if (input[0] == 0)
    return input;

  retstr = (char *) malloc (strlen (input) * sizeof (char) + 1);
  if (retstr == NULL)
    {
      perror ("Error");
      return NULL;
    }

  for (x = 0; x < strlen (input); x++)
    {
      if ((input[x] > 0x2f) && (input[x] < 0x3A))
	{
	  retstr[x] = ' ';
	}
      else
	retstr[x] = input[x];
    }
  retstr[x] = 0;

  return retstr;
}



char *
br2nl (char *input)
{
  char *retstr, c0, c1, c2, c3;
  unsigned long long x, y;

  if (input == NULL)
    return input;

  if (input[0] == 0)
    return input;

  retstr = (char *) malloc (strlen (input) * sizeof (char) + 1);
  if (retstr == NULL)
    {
      perror ("Error");
      return NULL;
    }

  c0 = c1 = c2 = c3 = 0;

  for (x = 0, y = 0; x < strlen (input); x++)
    {
      c0 = c1;
      c1 = c2;
      c2 = c3;
      c3 = input[x];
      if ((c0 == '[') && ((c1 == 'b') || (c1 == 'B'))
	  && ((c2 == 'r') || (c2 == 'r')) && (c3 == ']'))
	{
	  c3 = '\n';
	  y -= 3;
	}
      retstr[y] = c3;
      y++;
    }
  retstr[y] = 0;

  return retstr;
}


char
is_line_number (char *line)
{
  char f;
  long x, l;

  f = 0;
  l = strlen (line);
  for (x = 0; x < l; x++)
    if ((line[x] < 0x30) || (line[x] > 39))
      f = 1;

  return f;
}


char *
crnl2pipe (char *input)
{
  char *retstr;
  unsigned long long x;

  if (input == NULL)
    return input;

  if (input[0] == 0)
    return input;

  retstr = (char *) malloc (strlen (input) * sizeof (char) + 1);
  if (retstr == NULL)
    {
      perror ("Error");
      return NULL;
    }

  for (x = 0; x < strlen (input); x++)
    {
      if (input[x] == '\r')
	retstr[x] = ' ';
      else if (input[x] == '\n')
	retstr[x] = '|';
      else
	retstr[x] = input[x];
    }
  retstr[x] = 0;

  return retstr;
}
