#include <stdio.h>
#include <string.h>


double subfmt2seconds (char *);
double srtfmt2seconds (char *);


char *
subread_txt (FILE * fp, FILE * fpout, unsigned long *tbl, unsigned long *tel)
{
  char *line;
  long x;

  *tbl = 0, *tel = 0;
  line = (char *) trimcrlf (fgetline (fp));

  if (is_txt (line))
    {
      sscanf ((char *) strstr (line, "{") + 1, "%u", tbl);
      sscanf ((char *) strstr (strstr (line, "{") + 1, "{") + 1, "%u", tel);
      line = (char *) strstr (strstr (line, "}") + 1, "}") + 1;
      for (x = 0; x < strlen (line); x++)
	if (line[x] == '|')
	  line[x] = '\n';
      return line;
    }
  else
    {
      fprintf (fpout, "\n%s", line);
      return NULL;
    }
}


char *
subread_srt (FILE * fp, FILE * fpout, double *tbd, double *ted)
{
  char *line, *addline, *tbegin, *tend;
  long i, x;

  *tbd = 0., *ted = 0.;
  line = (char *) trimcrlf (fgetline (fp));

  if (is_srt (line))
    {
      tbegin = (char *) removeblanks (line);
      for (i = 0; i < strlen (tbegin); i++)
	if (tbegin[i] == '-')
	  tbegin[i] = '\0';
      tend = (char *) strstr ((char *) removeblanks (line), "-->") + 3;
      *tbd = srtfmt2seconds (tbegin);
      *ted = srtfmt2seconds (tend);
      line = addline = (char *) trimcrlf (fgetline (fp));
      while (!feof (fp) && strcmp ((char *) removeblanks (addline), ""))
	{
	  addline = (char *) trimcrlf (fgetline (fp));
	  if (addline != NULL)
	    if (addline[0] != 0)
	      {
		line =
		  (char *) realloc (line,
				    (strlen (line) + strlen (addline) +
				     2) * sizeof (char));
		strcat (line, "\n");
		strcat (line, addline);
	      }
	}
      return line;
    }
  else
    {
      if (!is_line_number (line))
	fprintf (fpout, "\n%s", line);
      return NULL;
    }
}


char *
subread_sub (FILE * fp, FILE * fpout, double *tbd, double *ted,
	     char *sub_begin)
{
  char *line, *addline, *tbegin, *tend;
  long i, x;

  *tbd = 0., *ted = 0.;
  line = (char *) trimcrlf (fgetline (fp));

  if (is_sub (line))
    {
      *sub_begin = 1;
      tbegin = (char *) removeblanks (line);
      for (i = 0; i < strlen (tbegin); i++)
	if (tbegin[i] == ',')
	  tbegin[i] = '\0';
      tend = (char *) strstr ((char *) removeblanks (line), ",") + 1;
      *tbd = subfmt2seconds (tbegin);
      *ted = subfmt2seconds (tend);
      line = addline = (char *) trimcrlf (fgetline (fp));
      while (!feof (fp) && strcmp ((char *) removeblanks (addline), ""))
	{
	  addline = (char *) trimcrlf (fgetline (fp));
	  if (addline != NULL)
	    if (addline[0] != 0)
	      {
		line =
		  (char *) realloc (line,
				    (strlen (line) + strlen (addline) +
				     2) * sizeof (char));
		strcat (line, "\n");
		strcat (line, addline);
	      }
	}
      line = (char *) br2nl (line);
      return line;
    }
  else
    {
      if (*sub_begin)
	fprintf (fpout, "\n%s", line);
      return NULL;
    }
}
